#!/usr/bin/ruby

# MainMenu.nib の場合
#
# 最初に xcode でローカライズして Japanese.lproj 内に MainMenu.nib を作成。
#
# あらかじめ定義してある EnglishMenu.strings、JapaneseMenu.strings を参考にしてローカライズすることができます。
#
# スクリプト、utf16menu.rb、utf16menu.sh があるフォルダに ib.sh で作成した English.strings
# Japanese.strings を置く。
#
# utf16menu.sh を実行する。
#
# Japanese.strings をゴミ箱に移動。
#
# 作成された utf16Japanese.strings のファイル名を Japanese.strings に変更
#
# ib.sh で update
#

require 'iconv'

englishData = ""
japaneseData = ""
utf8Data = ""

def menuHash(name, hashdata)
	data = ""

	iconv = Iconv.new('utf-8', 'utf-16')

	File.open(name, 'r') { |file|
		temp = file.read
		data = iconv.iconv(temp)
	#	print data
	}

	data.each { |item|

		if /^\"(\d+\..*?)\"\s+=\s+\"(.*?)\".*/ =~ item then

			hashdata[$1] = $2
#			print $1, $2
		end
	#	print item
	}
end

englishHash = Hash.new("")
japaneseHash = Hash.new("")

menuHash("EnglishMenu.strings", englishHash)
menuHash("JapaneseMenu.strings", japaneseHash)

keyHash = Hash.new("")

englishHash.each { |key, value| 

		if japaneseHash.key?(key) then
#			print key, " ", value, "\n"
			hKey = value
			hValue = japaneseHash[key]

			keyHash[hKey] = hValue
		end
}

keyHash.each { |key, value|
#	print key, " ", value, "\n"
}

iconv = Iconv.new('utf-8', 'utf-16')

File.open("japanese.strings", 'r') { |file|
	temp = file.read
	data = iconv.iconv(temp)

	data.each { |item|
		line = item

		if  /^\"(\d+\..*?)\"\s+=\s+\"(.*?)\".*/ =~ item then
				if keyHash.key?($2) then
					line = item.gsub(/^\"(\d+\..*?)\"\s+=\s+\"(.*?)\".*/) { |matched|
						%Q{"} + $1 + %Q{" = "} + keyHash[$2] + %Q{";}
					}
				end
		end

		utf8Data << line
	}
}

iconv = Iconv.new('utf-16', 'utf-8')

File.open("utf16Japanese.strings", 'w') { |file|
	data = iconv.iconv(utf8Data)
	file.print data
}
