//
//  PreferencesController.m
//  PCG-LinkMac
//
//  Created by Koyama Yoshiaki on 10/05/01.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PreferencesController.h"
#import "PCG_LinkMacAppDelegate.h"

@implementation PreferencesController

@synthesize gPreferencesWindow;

@synthesize gDeviceComboBox;
@synthesize gBaudRatePopUpButton;
@synthesize gDataBitPopUpButton;
@synthesize gStopBitPopUpButton;
@synthesize gParityPopUpButton;
@synthesize gFlowPopUpButton;
@synthesize gCheckEndOfFile;

@synthesize gDelegate;

/*
 
 */
- (void)awakeFromNib {
//	NSLog(@"awakeFromNib:PreferencesController\n");

	[gPreferencesWindow center];
	
//	[gDeviceComboBox setHasVerticalScroller:NO];
	[gDeviceComboBox setNumberOfVisibleItems:15];
	[self defaults];
}

/*
 
 */
- (IBAction)save:(id)sender {
	NSUserDefaults *defaults;
	NSString *dDeviceName;
	Menu_baud_rate m_baud_rate;
	Menu_data_bit m_data_bit;
	Menu_stop_bit m_stop_bit;
	Menu_parity m_parity;
	Menu_flow m_flow;
	Menu_check_end_of_file m_check;
	
	defaults = [NSUserDefaults standardUserDefaults];

	// device
	dDeviceName = [gDeviceComboBox stringValue];
	if (dDeviceName != nil) {
		[defaults setObject:dDeviceName forKey:PCG_DEVICE_NAME];
	}

	// baud rate
	m_baud_rate = [gBaudRatePopUpButton indexOfSelectedItem];
	m_baud_rate++;
	[defaults setInteger:m_baud_rate forKey:PCG_BAUD_RATE];
	
	// data bit
	m_data_bit = [gDataBitPopUpButton indexOfSelectedItem];
	m_data_bit++;
	[defaults setInteger:m_data_bit forKey:PCG_DATA_BIT];
	
	// stop bit
	m_stop_bit = [gStopBitPopUpButton indexOfSelectedItem];
	m_stop_bit++;
	[defaults setInteger:m_stop_bit forKey:PCG_STOP_BIT];

	// parity
	m_parity = [gParityPopUpButton indexOfSelectedItem];
	m_parity++;
	[defaults setInteger:m_parity forKey:PCG_PARITY];

	// flow
	m_flow = [gFlowPopUpButton indexOfSelectedItem];
	m_flow++;
	[defaults setInteger:m_flow forKey:PCG_FLOW];

	// check end of file
	if ([gCheckEndOfFile state] == NSOnState) {
		m_check = MENU_YES;
	} else {
		m_check = MENU_NO;
	}
	[defaults setInteger:m_check forKey:PCG_CHECK_END_OF_FILE];

	
	[defaults synchronize];

	[gDelegate changeStatus];
	
	[gPreferencesWindow performClose:self];


}

/*
 
 */
- (void)defaults {
	NSUserDefaults *defaults;
	NSString *dDeviceName;
	Menu_baud_rate m_baud_rate;
	Menu_data_bit m_data_bit;
	Menu_stop_bit m_stop_bit;
	Menu_parity m_parity;
	Menu_flow m_flow;
	Menu_check_end_of_file m_check;
	
	defaults = [NSUserDefaults standardUserDefaults];
	dDeviceName = [defaults stringForKey:PCG_DEVICE_NAME];

	if (dDeviceName == nil) {
		[defaults setObject:@"" forKey:PCG_DEVICE_NAME];
	} else {
		[gDeviceComboBox setStringValue:dDeviceName];
	}
	
	// baud rate
	m_baud_rate = [defaults integerForKey:PCG_BAUD_RATE];
	if (m_baud_rate == MENU_BNIL) {
		m_baud_rate = MENU_B9600;		
	}
	[defaults setInteger:m_baud_rate forKey:PCG_BAUD_RATE];
	[gBaudRatePopUpButton selectItemAtIndex:m_baud_rate-1];

	// data bit
	m_data_bit = [defaults integerForKey:PCG_DATA_BIT];
	if (m_data_bit == MENU_DNIL) {
		m_data_bit = MENU_D8;
	}
	[defaults setInteger:m_data_bit forKey:PCG_DATA_BIT];
	[gDataBitPopUpButton selectItemAtIndex:m_data_bit-1];

	// stop bit
	m_stop_bit = [defaults integerForKey:PCG_STOP_BIT];
	if (m_stop_bit == MENU_SNIL) {
		m_stop_bit = MENU_S1;
	}
	[defaults setInteger:m_stop_bit forKey:PCG_STOP_BIT];
	[gStopBitPopUpButton selectItemAtIndex:m_stop_bit-1];

	// parity
	m_parity = [defaults integerForKey:PCG_PARITY];
	if (m_parity == MENU_PNIL) {
		m_parity = MENU_ODD;
	}
	[defaults setInteger:m_parity forKey:PCG_PARITY];
	[gParityPopUpButton selectItemAtIndex:m_parity-1];

	// flow
	m_flow = [defaults integerForKey:PCG_FLOW];
	if (m_flow == MENU_FNIL) {
		m_flow = MENU_FNONE;
	}
	[defaults setInteger:m_flow forKey:PCG_FLOW];
	[gFlowPopUpButton selectItemAtIndex:m_flow-1];

	// Check end of file
	m_check = [defaults integerForKey:PCG_CHECK_END_OF_FILE];
	if (m_check == MENU_CNIL) {
		m_check = MENU_YES;
	}
	[defaults setInteger:m_check forKey:PCG_CHECK_END_OF_FILE];
	if (m_check == MENU_YES) {
		[gCheckEndOfFile setState:NSOnState];
	} else {
		[gCheckEndOfFile setState:NSOffState];
	}
	
	[defaults synchronize];
}

/*
 
 */
- (NSMutableArray *)arrayDevice {
	NSFileManager *fileManager;
	NSArray *lists;
	NSError *error;
	NSString *dev = @"/dev";
	NSString *path;
	BOOL isDirectory;
	BOOL exist;
	NSMutableArray *array;
	NSRange range, ttyRange;
	
	array = [NSMutableArray array];
	
	range.location = 0;
	range.length = 2;

	ttyRange.location = 0;
	ttyRange.length = 4;
	
	fileManager = [NSFileManager defaultManager];
	
	lists = [fileManager contentsOfDirectoryAtPath:@"/dev" error:&error];

	for (NSString *file in lists) {
		path = [dev stringByAppendingPathComponent:file];
	
		exist = [fileManager fileExistsAtPath:path isDirectory:&isDirectory];
		
		if ((exist == YES) && (isDirectory == NO)) {
			if ([file compare:@"cu" options: NSCaseInsensitiveSearch range:range] == NSOrderedSame) {
				[array addObject:path];
			} else if ([file compare:@"tty." options: NSCaseInsensitiveSearch range:ttyRange] == NSOrderedSame) {
				[array addObject:path];		
			}

		}
	}

	[array sortUsingSelector:@selector(caseInsensitiveCompare:)];	 

	return array;
}

/*
 
 */
- (IBAction)cancel:(id)sender {
	[self defaults];
	[gPreferencesWindow performClose:self];
}

/*
 
 */
- (NSInteger)numberOfItemsInComboBox:(NSComboBox *)aComboBox {
	return [[self arrayDevice] count];
}

/*
 
 */
- (id)comboBox:(NSComboBox *)aComboBox objectValueForItemAtIndex:(NSInteger)index {
	return [[self arrayDevice] objectAtIndex:index];
}

/*
 
 */
- (void)dealloc {
	
	[gPreferencesWindow release];

	[gDeviceComboBox release];
	[gBaudRatePopUpButton release];
	[gDataBitPopUpButton release];
	[gStopBitPopUpButton release];
	[gParityPopUpButton release];
	[gFlowPopUpButton release];
	[gCheckEndOfFile release];
	
	[gDelegate release];
	
	
	[super dealloc];
}

@end
