//
//  ReceiveController.m
//  PCG-LinkMac
//
//  Created by Koyama Yoshiaki on 10/05/05.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ReceiveController.h"
#import "PCG_LinkMacAppDelegate.h"

@implementation ReceiveController
@synthesize gReceiveButton;
@synthesize gSaveButton;
@synthesize gReceiveIndicator;
@synthesize gReceiveTextView;

@synthesize gReceiveThread;
@synthesize gDuration;
@synthesize gReceiveData;
@synthesize gDelegate;

/*
 
 */
- (void)awakeFromNib {
//	NSLog(@"awakeFromNib:receiveController\n");
	NSString *receive;
	
	receive = NSLocalizedString(@"pcg_receive_duration", @"");
//	NSLog(@"receive duration = %@\n", receive);
	
	self.gDuration = [receive floatValue];
	self.gReceiveData = [NSMutableData data];
}


- (IBAction)openReceiveDoc:(id)sender
{
	NSSavePanel *panel = [NSSavePanel savePanel];
	NSInteger result;
	NSString *path;
	BOOL flag;
	
	result = [panel runModal];
	
    if (result == NSFileHandlingPanelOKButton) {
        NSURL *url = [panel URL];		
		path = [url path];
		
		flag = [gReceiveData writeToFile:path atomically:YES];
		
		if (flag) {
//			NSLog(@"write sucess\n");
		} else {
//			NSLog(@"write failure\n");
		}
	}

}

/*
 
 */
- (void)startReceive:(id)info {
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    
    // Give the sound thread high priority to keep the timing steady.
    [NSThread setThreadPriority:1.0];

    BOOL continueThread = YES;
	unsigned char buffer[RECEIVE_BUFFER];
	
	fd_set inputs;
	fd_set testfds;	
	int result;
	int nread;
	
	struct timeval timeout;
	
		FD_ZERO(&inputs);

	if ((gDelegate.fd != -1) && (gDelegate.gTcgetAttr == YES)) {
		FD_SET(gDelegate.fd, &inputs);
	}
	while (continueThread) {
		NSAutoreleasePool *loopPool = [[NSAutoreleasePool alloc] init]; 
		BOOL inputFlag = NO;
		
		timeout.tv_sec = 1.0;
		timeout.tv_usec =500000;
		result = 0;
		
		testfds = inputs;
		
		if ((gDelegate.fd != -1) && (gDelegate.gTcgetAttr == YES)) {
			result = select(gDelegate.fd+1, &testfds, NULL, NULL, &timeout);
//			result = select(FD_SETSIZE, &testfds, NULL, NULL, &timeout);
		}		

		switch(result) {
			case 0:
//				NSLog(@"timeout\n");
				break;
			case -1:
				NSLog(@"Select() error\n");
				continueThread = NO;
				break;
			default:
				if ((gDelegate.fd != -1) && (gDelegate.gTcgetAttr == YES)) {
					if(FD_ISSET(gDelegate.fd, &testfds)) {
//						ioctl(0,FIONREAD,&nread);
//						nread = read(gDelegate.fd, buffer, 1);
//						nread = read(gDelegate.fd, buffer, 255);
						nread = read(gDelegate.fd, buffer, RECEIVE_BUFFER-1);
						
						if ((nread !=0) && (nread != -1)) {
							buffer[nread] = 0;
							inputFlag = YES;
//							NSLog(@"%d\n", nread);
//							NSLog(@"%d : %s", nread, buffer);					
						}
					}
				}					
				break;
		}

		if (inputFlag == YES) {
			NSData *data = [NSData dataWithBytes:buffer length:(NSUInteger)nread];								
			[self performSelectorOnMainThread:@selector(animate:) withObject:data waitUntilDone:NO];
		}
		
        NSDate *curtainTime = [[NSDate alloc] initWithTimeIntervalSinceNow:self.gDuration];
        NSDate *currentTime = [[NSDate alloc] init];

		while (continueThread && ([currentTime compare:curtainTime] != NSOrderedDescending)) { 
            if ([gReceiveThread isCancelled] == YES) {
                continueThread = NO;
            }
            [NSThread sleepForTimeInterval:0.01];
			[currentTime release];
            currentTime = [[NSDate alloc] init];
        }

		[curtainTime release];		
		[currentTime release];		
        [loopPool drain];
	}
	
    [pool drain];
}

/*
 
 */
- (void)waitReceiveThreadToFinish {
    while (gReceiveThread && ![gReceiveThread isFinished]) {
        [NSThread sleepForTimeInterval:0.1];
    }
	self.gReceiveThread = nil;
}

/*
 
 */
- (void)startReceiveThread {
    if (gReceiveThread != nil) {
        [gReceiveThread cancel];
        [self waitReceiveThreadToFinish];
    }
    
    NSThread *thread = [[[NSThread alloc] initWithTarget:self selector:@selector(startReceive:) object:nil] autorelease];
    self.gReceiveThread = thread;

	[gReceiveIndicator startAnimation:self];
  
	[self.gReceiveThread start];
}

/*
 
 */
- (IBAction)receiveAction:(id)sender {
	NSRange aRange;

	if (self.gReceiveThread != nil) {
        [gReceiveThread cancel];
		[self waitReceiveThreadToFinish];
		[gReceiveIndicator stopAnimation:self];
		[gReceiveButton setTitle:NSLocalizedString(@"receive", @"")];
	} else {
		self.gReceiveData = [NSMutableData data];
		aRange.location = 0;
		aRange.length = 0;

		[gReceiveTextView setString:@""];	
		[gReceiveTextView scrollRangeToVisible:aRange];
		
		[self startReceiveThread];
		[gReceiveButton setTitle:NSLocalizedString(@"stop", @"")];
		[gSaveButton setEnabled:YES];
	}
}

/*
 
 */
- (void)animate:(NSData *)data {
	NSRange aRange;
	NSString *string;
	
	[data retain];
	
	[self.gReceiveData appendData:data];

	string = [[[NSString alloc] initWithData:gReceiveData encoding:NSUTF8StringEncoding] autorelease];
//	aRange.location = [string length]; 
//	aRange.length = 1;

	[gReceiveTextView setString:string];

	string = [gReceiveTextView string];
	aRange.location = [string length]; 
	aRange.length = 1;
	
	[gReceiveTextView scrollRangeToVisible:aRange];

	[data release];
}

/*
 
 */
- (void)dealloc {
	[gReceiveButton release];
	[gSaveButton release];
	[gReceiveIndicator release];
	[gReceiveTextView release];
	
	[gReceiveThread release];
	
	[gReceiveData release];
	
	[gDelegate release];
	
	
	[super dealloc];
}

@end
