//
//  SendController.m
//  PCG-LinkMac
//
//  Created by Koyama Yoshiaki on 10/05/02.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "SendController.h"
#import "PCG_LinkMacAppDelegate.h"

@implementation SendController

@synthesize gSendButton;
@synthesize gSendIndicator;
@synthesize gSendTextField;
@synthesize gSendFrom;
@synthesize gSendThread;
@synthesize gDuration;

@synthesize gDelegate;

/*
 
 */
- (void)windowWillClose:(NSNotification *)notification {
	[NSApp terminate:self];
}


/*
 
 */
- (void)awakeFromNib {
//	NSLog(@"awakeFromNib:SendController\n");
	NSString *send;
	
	send = NSLocalizedString(@"pcg_send_duration", @"");
//	NSLog(@"send duration = %@\n", send);
	
	[gSendIndicator setHidden:YES];
	self.gDuration = [send floatValue];
}

/*
 
 */
- (IBAction)openSendDoc:(id)sender
{
    NSOpenPanel *panel = [NSOpenPanel openPanel];
	NSInteger result;
	
	[panel setCanChooseFiles:YES];
	[panel setCanChooseDirectories:NO];
	[panel setAllowsMultipleSelection:NO];

	result = [panel runModal];
	
    if (result == NSFileHandlingPanelOKButton) {
        NSArray *files = [panel URLs];
		for (NSURL *file in files) {
//			NSLog(@"%@ ",  NSClassFromString(file));
		}

		self.gSendFrom = [[files objectAtIndex:0] path];
		[gSendTextField setStringValue:gSendFrom];
//		NSLog(@"%@", gSendFrom);

		[gSendButton setEnabled:YES];
	}
}

/*
 
 */
- (void)startSend:(id)info {
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
 	NSUserDefaults *defaults;   
    [NSThread setThreadPriority:1.0];
    BOOL continueThread = YES;
    unsigned char buffer[256];
	unsigned char back;
	NSRange range;
	NSInteger length;
	NSData *data;
	Menu_check_end_of_file m_check;
	
	back = 0;
	data = [NSData dataWithContentsOfFile:self.gSendFrom];
	length =[data length];

	range.location = 0;
	range.length = 1;	
	
	defaults = [NSUserDefaults standardUserDefaults];	
	m_check = [defaults integerForKey:PCG_CHECK_END_OF_FILE];	
	
	NSArray *arrayKeys = [NSArray arrayWithObjects:@"min", @"max", @"value", nil];

	while (continueThread) {  // Loop until cancelled.
		
        // An autorelease pool to prevent the build-up of temporary objects.
        NSAutoreleasePool *loopPool = [[NSAutoreleasePool alloc] init]; 
		NSDictionary *dictionary;
		int byte;
		NSArray *arrayObjects = [NSArray arrayWithObjects:@"min", @"max", @"value", nil];
		
		if (range.location == length) {
			if ((back != 0x1a) && (m_check == MENU_YES)){
//				NSLog(@"No 1A\n");
				buffer[0] = 0x1a;
				if (write(gDelegate.fd, buffer, 1) != 1) {
					NSLog(@"Write() error\n");
				} else {
//					NSLog(@"%d %x ", gDelegate.fd, buffer[0]);
				}				
			}
			
			continueThread = NO;
		} else {
			[data getBytes:(void *)buffer range:range];
			back = buffer[0];
			byte = (int)buffer[0];
			
			if (write(gDelegate.fd, buffer, range.length) != range.length) {
				NSLog(@"write() error\n");
			} else {
//				NSLog(@"%d %x ", gDelegate.fd, byte);
			}
		}

		arrayObjects = [NSArray arrayWithObjects:[NSNumber numberWithDouble:0], [NSNumber numberWithDouble:length], [NSNumber numberWithDouble:range.location], nil];
		
		dictionary = [NSDictionary dictionaryWithObjects:arrayObjects forKeys:arrayKeys];

        [self performSelectorOnMainThread:@selector(animate:) withObject:dictionary waitUntilDone:NO];

        NSDate *curtainTime = [[NSDate alloc] initWithTimeIntervalSinceNow:self.gDuration];
        NSDate *currentTime = [[NSDate alloc] init];
        
        // Wake up periodically to see if we've been cancelled.
		range.location++;
        
		while (continueThread && ([currentTime compare:curtainTime] != NSOrderedDescending)) { 
            if ([gSendThread isCancelled] == YES) {
                continueThread = NO;
            }
            [NSThread sleepForTimeInterval:0.01];
			[currentTime release];
            currentTime = [[NSDate alloc] init];
        }
		[curtainTime release];		
		[currentTime release];		
        [loopPool drain];
    }
    [pool drain];
}


- (void)waitSendThreadToFinish {
    while (gSendThread && ![gSendThread isFinished]) {
        [NSThread sleepForTimeInterval:0.1];
    }
	self.gSendThread = nil;
}

/*
 
 */
- (void)startSendThread {
    if (gSendThread != nil) {
        [gSendThread cancel];
        [self waitSendThreadToFinish];
    }
    
    NSThread *thread = [[[NSThread alloc] initWithTarget:self selector:@selector(startSend:) object:nil] autorelease];
    self.gSendThread = thread;
	
    [self.gSendThread start];
}

/*
 
 */
- (IBAction)sendAction:(id)sender {
	NSAlert *alert = [[[NSAlert alloc] init] autorelease];
	NSFileManager *fileManager;
	BOOL isDirectory;
	
	fileManager = [NSFileManager defaultManager];
	
	[alert addButtonWithTitle:@"OK"];
	[alert setAlertStyle:NSWarningAlertStyle];
	
	[alert setMessageText:NSLocalizedString(@"error", @"")];
	[alert setInformativeText:
	 [NSString stringWithFormat:NSLocalizedString(@"not_open_the_file", @""), [self.gSendFrom lastPathComponent]]];
	
	
	if (self.gSendThread != nil) {
        [gSendThread cancel];
		[self waitSendThreadToFinish];
		[gSendIndicator stopAnimation:self];
		[gSendIndicator setHidden:YES];
		[gSendButton setTitle:NSLocalizedString(@"send", @"")];
		[gSendIndicator setDoubleValue:0];
	} else {
		
		if ([fileManager fileExistsAtPath:self.gSendFrom isDirectory:&isDirectory] == YES) {

			if (isDirectory == NO) {
				[self startSendThread];
				[gSendIndicator setHidden:NO];
				[gSendButton setTitle:NSLocalizedString(@"stop", @"")];
			} else {
				[alert runModal];
			}
		} else {
			[alert runModal];				
		}
	}
}

/*
 
 */
- (void)animate:(NSDictionary *)dictionary {
	double min, max, value;
	
	[dictionary retain];

	min = [[dictionary objectForKey:@"min"] doubleValue];
	max = [[dictionary objectForKey:@"max"] doubleValue];
	value = [[dictionary objectForKey:@"value"] doubleValue];

	if (value <= 0) {
		[gSendIndicator setMinValue:min];
		[gSendIndicator setMaxValue:max];
		[gSendIndicator setDoubleValue:min];
		[gSendIndicator startAnimation:self];
	} else if (value >= max) {
		[gSendIndicator setDoubleValue:max];
		[gSendIndicator stopAnimation:self];
		[self sendAction:self];
	} else {
		[gSendIndicator setDoubleValue:value];	
	}

	[dictionary release];
}

/*
 
 */
- (void)dealloc {
	
	[gSendButton release];
	[gSendIndicator release];
	[gSendTextField release];
	
	[gSendFrom release];
	
	[gSendThread release];	
	[gDelegate release];
		
	[super dealloc];
}

@end
